/*

    qmailalizer - a qmail-send log analysis program

    Copyright (C) 2001  Pichler Wolfgang  (wpichler@dialog-gruppe.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version, and provided that the above
    copyright and permission notice is included with all distributed
    copies of this or derived software.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

    This software uses the gd graphics library, which is copyright by
    Quest Protein Database Center, Cold Spring Harbor Labs.  Please
    see the documentation supplied with the library for additional
    information and license terms, or visit www.boutell.com/gd/ for the
    most recent version of the library and supporting documentation.


*/

#ifndef STUFF_H
#include "stuff.h"
#include <string.h>
#include <ctype.h>

char *utoa(unsigned value, char *digits, int base)
{
  char *s, *p;

  s = "0123456789abcdefghijklmnopqrstuvwxyz"; /* don't care if s is in
                                               * read-only memory
						                                                  */
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < (unsigned) base) {
     digits[0] = s[value];
     digits[1] = '\0';
   } else {
     for (p = utoa(value / ((unsigned)base), digits, base);*p;p++);
     utoa( value % ((unsigned)base), p, base);
  }
  return digits;
} 
												  
												  
char *itoa(int value, char *digits, int base)
{ char *d;
  unsigned u; /* assume unsigned is big enough to hold all the
	       * unsigned values -x could possibly be -- don't
               * know how well this assumption holds on the
               * DeathStation 9000, so beware of nasal demons
               */
  d = digits;
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < 0) {
    *d++ = '-';
    u = -value;
  } else
    u = value;
  utoa(u, d, base);
  return digits;
}
								    
unsigned char *utoa(unsigned value, unsigned char *digits, int base)
{
  unsigned char *p;
  char *s;

  s = "0123456789abcdefghijklmnopqrstuvwxyz"; /* don't care if s is in
                                               * read-only memory
						                                                  */
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < (unsigned) base) {
     digits[0] = s[value];
     digits[1] = '\0';
   } else {
     for (p = utoa(value / ((unsigned)base), digits, base);*p;p++);
     utoa( value % ((unsigned)base), p, base);
  }
  return digits;
} 

unsigned char *itoa(int value, unsigned char *digits, int base)
{ unsigned char *d;
  unsigned u; /* assume unsigned is big enough to hold all the
	       * unsigned values -x could possibly be -- don't
               * know how well this assumption holds on the
               * DeathStation 9000, so beware of nasal demons
               */
  d = digits;
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < 0) {
    *d++ = '-';
    u = -value;
  } else
    u = value;
  utoa(u, d, base);
  return digits;
}

unsigned char *ltoa(long value, unsigned char *digits, int base)
{ unsigned char *d;
  unsigned u; /* assume unsigned is big enough to hold all the
	       * unsigned values -x could possibly be -- don't
               * know how well this assumption holds on the
               * DeathStation 9000, so beware of nasal demons
               */
  d = digits;
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < 0) {
    *d++ = '-';
    u = -value;
  } else
    u = value;
  utoa(u, d, base);
  return digits;
}

int strpos(char *s,char c)
{ int pos;

  pos = strchr(s,(int)c) - s;
  if (pos > 0)
    return pos;
  else
    return 0;
}		

char *strlower(char *s)
{ unsigned int i;

  for (i=0;i<strlen(s);i++) {s[i] = (char) tolower((int)s[i]);}
  return s;
}

unsigned char *ltoa(unsigned long value, unsigned char *digits, int base)
{ unsigned char *d;
  unsigned u; /* assume unsigned is big enough to hold all the
	       * unsigned values -x could possibly be -- don't
               * know how well this assumption holds on the
               * DeathStation 9000, so beware of nasal demons
               */
  d = digits;
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < 0) {
    *d++ = '-';
    u = -value;
  } else
    u = value;
  utoa(u, d, base);
  return digits;
}


unsigned char *dtoa(double value, unsigned char *digits, int base)
{ unsigned char *d;
  double u; /* assume unsigned is big enough to hold all the
	       * unsigned values -x could possibly be -- don't
               * know how well this assumption holds on the
               * DeathStation 9000, so beware of nasal demons
               */
  d = digits;
  if (base == 0)
    base = 10;
  if (digits == NULL || base < 2 || base > 36)
    return NULL;
  if (value < 0) {
    *d++ = '-';
    u = -value;
  } else
    u = value;
  utoa(u, d, base);
  return digits;
}

#endif
						    